<?php
 class apiMemcacheCache extends apiCache { private $connection = false; public function __construct() { global $apiConfig; if (! function_exists('memcache_connect')) { throw new apiCacheException("Memcache functions not available"); } $this->host = $apiConfig['ioMemCacheCache_host']; $this->port = $apiConfig['ioMemCacheCache_port']; if (empty($this->host) || empty($this->port)) { throw new apiCacheException("You need to supply a valid memcache host and port"); } } private function isLocked($key) { $this->check(); if ((@memcache_get($this->connection, $key . '.lock')) === false) { return false; } return true; } private function createLock($key) { $this->check(); @memcache_add($this->connection, $key . '.lock', '', 0, 5); } private function removeLock($key) { $this->check(); @memcache_delete($this->connection, $key . '.lock'); } private function waitForLock($key) { $this->check(); $tries = 20; $cnt = 0; do { usleep(250); $cnt ++; } while ($cnt <= $tries && $this->isLocked($key)); if ($this->isLocked($key)) { $this->removeLock($key); } } private function connect() { if (! $this->connection = @memcache_pconnect($this->host, $this->port)) { throw new apiCacheException("Couldn't connect to memcache server"); } } private function check() { if (! $this->connection) { $this->connect(); } } public function get($key, $expiration = false) { $this->check(); if (($ret = @memcache_get($this->connection, $key)) === false) { return false; } if (! $expiration || (time() - $ret['time'] > $expiration)) { $this->delete($key); return false; } return $ret['data']; } public function set($key, $value) { $this->check(); if (@memcache_set($this->connection, $key, array('time' => time(), 'data' => $value), false) == false) { throw new apiCacheException("Couldn't store data in cache"); } } public function delete($key) { $this->check(); @memcache_delete($this->connection, $key); } } 